/* GROUND TEST
 * (c) 1999. Glen H. Barratt Productions
 *
 * Glen H. Barratt CS3H
 *
 * Code Started: Friday, 2/5/1999
 * Code Last Updated: Tuesday, 6/23/1999
 *
 * Programmed With: Allegro in DJGPP
 */

 // NOTES //

 // INCLUDES //

 #include <stdlib.h>
 #include <stdio.h>
 #include <dos.h>
 #include <dirent.h>
 #include "allegro.h"

 // DEFINES //
 #define MaxGroundMapX 25
 #define MaxGroundMapY 25
 #define MaxGroundTileSegs 26

 #define GroundMapSegX 2000
 #define GroundMapSegY 800

 #define TileSize 45

 #define PassiveC 63519

 char *GroundTileSegFile[MaxGroundTileSegs]={
  "TEXTURES/TEXTURE0.PCX",
  "TEXTURES/TEXTURE1.PCX",
  "TEXTURES/TEXTURE2.PCX",
  "TEXTURES/TEXTURE3.PCX",
  "TEXTURES/TEXTURE4.PCX",
  "TEXTURES/TEXTURE5.PCX",
  "TEXTURES/TEXTURE6_2.PCX",
  "TEXTURES/TEXTURE7.PCX",
  "TEXTURES/TEXTURE8.PCX",
  "TEXTURES/TEXTURE9.PCX",
  "TEXTURES/TEXTURE10.PCX",
  "TEXTURES/TEXTURE11.PCX",
  "TEXTURES/TEXTURE12.PCX",
  "TEXTURES/TEXTURE13.PCX",
  "TEXTURES/TEXTURE14.PCX",
  "TEXTURES/TEXTURE15.PCX",
  "TEXTURES/TEXTURE16.PCX",
  "TEXTURES/TEXTURE17.PCX",
  "TEXTURES/TEXTURE18.PCX",
  "TEXTURES/TEXTURE19.PCX",
  "TEXTURES/TEXTURE20.PCX",
  "TEXTURES/TEXTURE21.PCX",
  "TEXTURES/TEXTURE22.PCX",
  "TEXTURES/TEXTURE23.PCX",
  "TEXTURES/TEXTURE24.PCX",
  "TEXTURES/TEXTURE25.PCX"
 };


 // VARIABLES //

 BITMAP *VirSeg,*TempSeg,*Temp2Seg;
 BITMAP *BackImageSeg;
 BITMAP *GroundMapSeg;
 BITMAP *GroundTileSeg[20];
 PALETTE Pal;

 char Key;
 unsigned int MX, MXO, MY, MYO;
 unsigned int Xi,Yi,Zi,RX,RY,R1,R2;
 long LastResult;
 unsigned int MapX,MapY;
 unsigned long C1;
 int i,i2,i3;

 typedef struct GroundMapStruct{
  unsigned char SI1,SI2,SI3,SI4,SI5,SI6;
  unsigned char CZ1,CZ2,CZ3,CZ4,MZ;
  unsigned char Rotate;
  unsigned long LightC;
  unsigned char LightOpt;
  unsigned char LightPercent;
  unsigned int Special;
 }GroundMapStruct;

 GroundMapStruct GroundMap[MaxGroundMapX][MaxGroundMapY][3];

 struct time Time;
 struct dirent *de;

 // FUNCTIONS //

 int Show(char *Name){
  TempSeg=load_bitmap(Name,Pal);
  if(!TempSeg)return -1;
  blit(TempSeg,screen,0,0,0,0,640,480);
  while(!keypressed());
  if((readkey() & 0xFF)==27)return 1;
  return 1;
 }


 int DimScreen(int mode,int Color,BITMAP *DestSeg){
  int i,i2,i3,i4,Color2;
  unsigned char gr,gg,gb;
  mode=2;
  if(mode<5){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    putpixel(DestSeg,i*2,i2*2,Color);
   }
   if(mode>1){
    for(i2=0;i2<480/2;i2++)
    for(i=0;i<640/2;i++){
     putpixel(DestSeg,i*2+1,i2*2+1,Color);
    }
   }
  }
  if(mode==5){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    Color2=getpixel(DestSeg,i*2+1,i2*2)+(random()%Color);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==6){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    Color2=((getpixel(DestSeg,i*2,i2*2)+getpixel(DestSeg,i*2+1,i2*2)+
    getpixel(DestSeg,i*2,i2*2+1)+getpixel(DestSeg,i*2+1,i2*2+1))/4);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==7){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    gr=((getr(getpixel(DestSeg,i*2+1,i2*2))+getb(Color))/2);
    gg=((getg(getpixel(DestSeg,i*2+1,i2*2))+getb(Color))/2);
    gb=((getb(getpixel(DestSeg,i*2+1,i2*2))+getb(Color))/2);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==8){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    gr=((getr(getpixel(DestSeg,i*2,i2*2))+getr(getpixel(DestSeg,i*2+1,i2*2))+
    getr(getpixel(DestSeg,i*2,i2*2+1))+getr(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gg=((getg(getpixel(DestSeg,i*2,i2*2))+getg(getpixel(DestSeg,i*2+1,i2*2))+
    getg(getpixel(DestSeg,i*2,i2*2+1))+getg(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gb=((getb(getpixel(DestSeg,i*2,i2*2))+getb(getpixel(DestSeg,i*2+1,i2*2))+
    getb(getpixel(DestSeg,i*2,i2*2+1))+getb(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==9){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    gr=((getr(getpixel(DestSeg,i*2,i2*2))+getr(getpixel(DestSeg,i*2+1,i2*2))+
    getr(getpixel(DestSeg,i*2,i2*2+1))+getr(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gg=((getg(getpixel(DestSeg,i*2,i2*2))+getg(getpixel(DestSeg,i*2+1,i2*2))+
    getg(getpixel(DestSeg,i*2,i2*2+1))+getg(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gb=((getb(getpixel(DestSeg,i*2,i2*2))+getb(getpixel(DestSeg,i*2+1,i2*2))+
    getb(getpixel(DestSeg,i*2,i2*2+1))+getb(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
   for(i2=0;i2<480/2-1;i2++)
   for(i=0;i<640/2-1;i++){
    gr=((getr(getpixel(DestSeg,i*2+1,i2*2+1))+getr(getpixel(DestSeg,i*2+2,i2*2+1))+
    getr(getpixel(DestSeg,i*2+1,i2*2+2))+getr(getpixel(DestSeg,i*2+2,i2*2+2)))/4);
    gg=((getg(getpixel(DestSeg,i*2+1,i2*2+1))+getg(getpixel(DestSeg,i*2+2,i2*2+1))+
    getg(getpixel(DestSeg,i*2+1,i2*2+2))+getg(getpixel(DestSeg,i*2+2,i2*2+2)))/4);
    gb=((getb(getpixel(DestSeg,i*2+1,i2*2+1))+getb(getpixel(DestSeg,i*2+2,i2*2+1))+
    getb(getpixel(DestSeg,i*2+1,i2*2+2))+getb(getpixel(DestSeg,i*2+2,i2*2+2)))/4);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
    putpixel(DestSeg,i*2+2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+2,Color2);
    putpixel(DestSeg,i*2+2,i2*2+2,Color2);
   }
  }
  if(mode==10){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+getr(Color))/2);
    gg=((getg(getpixel(DestSeg,i,i2))+getg(Color))/2);
    gb=((getb(getpixel(DestSeg,i,i2))+getb(Color))/2);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==11){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+getr(Color)+
    getg(getpixel(DestSeg,i,i2))+getg(Color)+
    getb(getpixel(DestSeg,i,i2))+getb(Color))/6);
    Color2=makecol(gr,gr,gr);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==12){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(gr,gr,gr);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==13){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(gr,0,0);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==14){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(0,gr,0);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==15){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(0,0,gr);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
 }

 int LoadGroundTileSegs(){
  int i;
  for(i=0;i<MaxGroundTileSegs;i++){
   GroundTileSeg[i]=create_bitmap(45,45);
   GroundTileSeg[i]=load_pcx(GroundTileSegFile[i],Pal);
  }
 }


 int PlaceGroundTile(BITMAP *DestSeg,int X,int Y,unsigned int MapX,unsigned int MapY,unsigned int MapZ,unsigned int Ind,unsigned int Height, unsigned char Opt){
  int Xi,Yi,Zi;
  long LX,LY;
  int ZStep=35;
  int R1,G1,B1,R2,G2,B2;
  unsigned long C1,C2,C3,C4,C5,LightC;
  unsigned long BackgroundC=0;
  unsigned char LightPercent;
  unsigned int HeightDifference;
  unsigned char OffScreen;

  X=X+22;
  Y=Y+56;

  if(Opt==0)blit(GroundTileSeg[Ind],DestSeg,0,0,X,Y,TileSize,TileSize);
  if(Opt>0){
   for(Yi=0;Yi<TileSize;Yi++)
   for(Xi=0;Xi<TileSize;Xi++){
    OffScreen=0;
    if(Opt==1){
     LX=(X+(Xi+abs(Yi-TileSize))+0.0)*(7.0/8.0)-(TileSize/2.0)*(7.0/8.0);
     LY=(Y+0.0+(((Xi+Yi+0.0)-TileSize/2.0)/2.75)*(7.0/8.0)+1)
     -((1.00)*(TileSize-Xi+0.0)*(TileSize-Yi+0.0)*(ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ1/(TileSize*TileSize+0.0)+0.0)
     -((1.00)*(Xi*Yi*(ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ2+0.0)/(TileSize*TileSize+0.0)+0.0)
     -((1.00)*(TileSize-Xi+0.0)*Yi*(ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ3/(TileSize*TileSize+0.0)+0.0)
     -((1.00)*Xi*(TileSize-Yi+0.0)*(ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ4/(TileSize*TileSize+0.0)+0.0);
    }
    //if(Opt==2)C4=getpixel(VirSeg,X+Xi*(7.0/8.0)-(TileSize/(2.75*(7.0/8.0))),(Y+Yi+(Xi/(2.75/(7.0/8.0)))+(TileSize/5.50)-1);
    //if(Opt==3)C4=getpixel(VirSeg,X+Xi*(7.0/8.0)+(TileSize/(2.75*(7.0/8.0)))+1,Y+Yi+(TileSize/2.75)-(Xi/(2.75/(7.0/8.0)))+(TileSize/5.50)*(7.0/8.0)-2);
    if((LX<0)||(LX>GroundMapSegX))OffScreen=1;
    if((LY<0)||(LY>GroundMapSegY))OffScreen=1;

    if(!OffScreen){
    HeightDifference=abs(LY-(Y+0.0+(((Xi+Yi+0.0)-TileSize/2.0)/2.75)*(7.0/8.0)+1));

    if(GroundMap[MapX][MapY][MapZ].Rotate==0)C1=getpixel(GroundTileSeg[Ind],Xi,Yi);
    if(GroundMap[MapX][MapY][MapZ].Rotate==1)C1=getpixel(GroundTileSeg[Ind],(TileSize-1)-Xi,(TileSize-1)-Yi);
    if(GroundMap[MapX][MapY][MapZ].Rotate==2)C1=getpixel(GroundTileSeg[Ind],(TileSize-1)-Yi,Xi);
    if(GroundMap[MapX][MapY][MapZ].Rotate==3)C1=getpixel(GroundTileSeg[Ind],Yi,(TileSize-1)-Xi);
    R1=getr(C1);
    G1=getg(C1);
    B1=getb(C1);
    LightPercent=GroundMap[MapX][MapY][MapZ].LightPercent;
    if(GroundMap[MapX][MapY][MapZ].LightOpt==1){
     if(LightPercent){
      R2=getr(GroundMap[MapX][MapY][MapZ].LightC);
      G2=getg(GroundMap[MapX][MapY][MapZ].LightC);
      B2=getb(GroundMap[MapX][MapY][MapZ].LightC);
      LightC=makecol((R1*((100.0-LightPercent)/100.0)+R2*(LightPercent/100.0)),
      (G1*((100.0-LightPercent)/100.0)+G2*(LightPercent/100.0)),
      (B1*((100.0-LightPercent)/100.0)+B2*(LightPercent/100.0)));
     }
    }
    if(GroundMap[MapX][MapY][MapZ].LightOpt==2)
    LightC=makecol(HeightDifference/(ZStep/100.0),HeightDifference/(ZStep/100.0),HeightDifference/(ZStep/100.0));

    if(GroundMap[MapX][MapY][MapZ].LightOpt==3)
    LightC=makecol(
    (HeightDifference/(ZStep/100.0))*R1/255.0,
    (HeightDifference/(ZStep/100.0))*G1/255.0,
    (HeightDifference/(ZStep/100.0))*B1/255.0);

    if(GroundMap[MapX][MapY][MapZ].LightOpt==5){
     R2=getr(GroundMap[MapX][MapY][MapZ].LightC);
     G2=getg(GroundMap[MapX][MapY][MapZ].LightC);
     B2=getb(GroundMap[MapX][MapY][MapZ].LightC);
     LightC=makecol(
     (HeightDifference/(ZStep/100.0)*R2/255.0)*(LightPercent/100.0)+
     R1*((100.0-LightPercent)/100.0),
     (HeightDifference/(ZStep/100.0)*G2/255.0)*(LightPercent/100.0)+
     G1*((100.0-LightPercent)/100.0),
     (HeightDifference/(ZStep/100.0)*B2/255.0)*(LightPercent/100.0)+
     B1*((100.0-LightPercent)/100.0));
    }
//    LightC=makecol(
//    (HeightDifference/(ZStep/100.0))*(LightPercent/100.0)+
//    R1*((100.0-LightPercent)/100.0),
//    (HeightDifference/(ZStep/100.0))*(LightPercent/100.0)+
//    G1*((100.0-LightPercent)/100.0),
//    (HeightDifference/(ZStep/100.0))*(LightPercent/100.0)+
//    B1*((100.0-LightPercent)/100.0));

    if(GroundMap[MapX][MapY][MapZ].LightOpt==4){
     R2=getr(GroundMap[MapX][MapY][MapZ].LightC);
     G2=getg(GroundMap[MapX][MapY][MapZ].LightC);
     B2=getb(GroundMap[MapX][MapY][MapZ].LightC);
     LightC=makecol(HeightDifference/(ZStep/100.0)*R2/255.0,HeightDifference/(ZStep/100.0)*G2/255.0,HeightDifference/(ZStep/100.0)*B2/255.0);
    }

    C4=getpixel(DestSeg,LX,LY);
     if((C4!=0)||(C4!=C3)){
      R2=getr(C4);
      G2=getg(C4);
      B2=getb(C4);
     }
     if(GroundMap[MapX][MapY][MapZ].LightOpt>0)C3=LightC;
     else C3=C1;
     C4=C3;

     //if((Xi<1)||(Yi<1))C3=makecol((getr(C4)+R2)/2,(getg(C4)+G2)/2,(getb(C4)+B2)/2);
     if(Opt==1)putpixel(DestSeg,LX,LY,C3);

     R1=(GroundMap[MapX][MapY][MapZ].MZ);

     if((BackgroundC!=C3)&&(abs((ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ1-(ZStep/100.0)*R1)>70)&&((Yi<TileSize))&&(Yi<(TileSize-2)))putpixel(DestSeg,LX,LY+3,C3);
     if((BackgroundC!=C3)&&(abs((ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ1-(ZStep/100.0)*R1)>50)&&((Yi<TileSize))&&(Yi<(TileSize-1)))putpixel(DestSeg,LX,LY+2,C3);

     if((BackgroundC!=C3)&&((abs((ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ1-(ZStep/100.0)*R1)>20)||
     (abs((ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ2-(ZStep/100.0)*R1)>60)||
     (abs((ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ3-(ZStep/100.0)*R1)>60)||
     (abs((ZStep/100.0)*GroundMap[MapX][MapY][MapZ].CZ4-(ZStep/100.0)*R1)>60))){
      putpixel(VirSeg,LX,LY,C3);
      if((Yi>0))putpixel(DestSeg,LX,LY-1,C3);
      if((Yi<TileSize))putpixel(VirSeg,LX,LY+1,C3);
      if((Xi>0))putpixel(DestSeg,LX-1,LY,C3);
      if((Xi<TileSize))putpixel(DestSeg,LX+1,LY,C3);
     }
     else{
      if((getpixel(VirSeg,LX,LY-1)!=C3)&&(BackgroundC!=C3)&&(Yi>0))putpixel(DestSeg,LX,LY-1,C3);
      if((getpixel(VirSeg,LX,LY+1)!=C3)&&(BackgroundC!=C3)&&(Yi<TileSize))putpixel(DestSeg,LX,LY+1,C3);
      if((getpixel(VirSeg,LX-1,LY)!=C3)&&(BackgroundC!=C3)&&(Xi>0))putpixel(DestSeg,LX-1,LY,C3);
      if((getpixel(VirSeg,LX+1,LY)!=C3)&&(BackgroundC!=C3)&&(Xi<TileSize))putpixel(DestSeg,LX+1,LY,C3);
     }
     //if(Opt==2)putpixel(VirSeg,X+Xi*(7.0/8.0)-(TileSize/(2.75*(7.0/8.0))),Y+Yi+(Xi/(2.75/(7.0/8.0)))+(TileSize/5.50)-1,C3);
     //if(Opt==3)putpixel(VirSeg,X+Xi*(7.0/8.0)+(TileSize/(2.75*(7.0/8.0)))+1,Y+Yi+(TileSize/2.75)-(Xi/(2.75/(7.0/8.0)))+(TileSize/5.50)*(7.0/8.0)-2,C3);
     //if(Opt==0)putpixel(VirSeg,X+(Xi+abs(Yi-TileSize))/1.45-(TileSize/5),Y+((Xi+Yi))/1.45-(TileSize/5),C2);
    }
   }
  }
 }

 int FillGroundMapSegPassiveArea(){
  int X,Y;
  for(Y=0;Y<GroundMapSegY;Y++)
  for(X=0;X<GroundMapSegX;X++){
   if(getpixel(GroundMapSeg,X,Y)==0)putpixel(GroundMapSeg,X,Y,PassiveC);
  }
 }

 int ColorSegPassiveArea(BITMAP *DestSeg,unsigned char Opt,unsigned long Color1,unsigned long Color2){
  int X,Y;
  unsigned C1;
  unsigned char R1,G1,B1,R2,G2,B2;
  for(Y=0;Y<480;Y++)
  for(X=0;X<640;X++){
   if((getpixel(DestSeg,X,Y)==PassiveC)||(getpixel(DestSeg,X,Y)==0)){
    if(Opt==0)putpixel(DestSeg,X,Y,Color1);
    if(Opt==1){
     R2=getr(Color1);
     G2=getg(Color1);
     B2=getb(Color1);
     R1=getr(Color2);
     G1=getg(Color2);
     B1=getb(Color2);
     C1=makecol(R1*(Y/480.0)+R2*((480.0-Y)/480),G1*(Y/480.0)+G2*((480.0-Y)/480.0),B1*(Y/480.0)+B2*((480.0-Y)/480.0));
     putpixel(DestSeg,X,Y,C1);
    }
   }
  }
 }







 int ExitStuff(){
  destroy_bitmap(VirSeg);
  destroy_bitmap(TempSeg);
  destroy_bitmap(Temp2Seg);
  destroy_bitmap(GroundMapSeg);
  destroy_bitmap(BackImageSeg);
  //remove_sound();
  remove_mouse();
  remove_timer();
  clear_keybuf();
  remove_keyboard();
  allegro_exit();
  clrscr();
  printf("GROUND TEST (c) 1999. Glen H. Barratt Productions.");
  exit(0);
 }

 // MAIN //

 int main(int argc,char *argv[]){
  allegro_init();
  install_keyboard();
  install_timer();
  install_mouse();

  gettime(&Time);
  srandom(Time.ti_sec);

  // Set best available color depth
  set_color_depth(16);
  if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
   set_color_depth(15);
   if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
    set_color_depth(32);
    if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
     set_color_depth(24);
     if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
      allegro_exit();
      printf("Error setting graphics mode\n%s\n\n", allegro_error);
      return 1;
     }
    }
   }
  }

  Reset:

  VirSeg=create_bitmap(640,480);
  GroundMapSeg=create_bitmap(GroundMapSegX,GroundMapSegY);
  BackImageSeg=create_bitmap(640,480);
  TempSeg=create_bitmap(640,480);
  Temp2Seg=create_bitmap(640,480);

  clear(VirSeg);
  clear(BackImageSeg);
  VirSeg=load_pcx("IMAGES/GCLAIMER.PCX",Pal);
  blit(VirSeg,screen,0,0,0,0,640,480);

  LoadGroundTileSegs();

  set_color_depth(8);
  set_gfx_mode(GFX_AUTODETECT,640,480,0,0);
  TempSeg=load_bmp("MAP.BMP",Pal);

  for(Yi=0;Yi<(MaxGroundMapY-1);Yi++)
  for(Xi=0;Xi<(MaxGroundMapX-1);Xi++){
   C1=getpixel(TempSeg,Xi+1,Yi+1);
   GroundMap[Xi][Yi][0].CZ2=C1;
   GroundMap[Xi+1][Yi][0].CZ3=C1;
   GroundMap[Xi][Yi+1][0].CZ4=C1;
   GroundMap[Xi+1][Yi+1][0].CZ1=C1;
  }
  for(Yi=0;Yi<(MaxGroundMapY-1);Yi++){
   C1=getpixel(TempSeg,0,Yi+1);
   GroundMap[0][Yi][0].CZ3=C1;
   GroundMap[0][Yi+1][0].CZ1=C1;
  }
  for(Xi=0;Xi<(MaxGroundMapX-1);Xi++){
   C1=getpixel(TempSeg,Xi+1,0);
   GroundMap[Xi][0][0].CZ4=C1;
   GroundMap[Xi+1][0][0].CZ1=C1;
  }
  C1=getpixel(TempSeg,0,0);
  GroundMap[0][0][0].CZ1=C1;
  C1=getpixel(TempSeg,MaxGroundMapX,MaxGroundMapY);
  GroundMap[MaxGroundMapX-1][MaxGroundMapY-1][0].CZ2=C1;

  C1=getpixel(TempSeg,0,MaxGroundMapY);
  GroundMap[0][MaxGroundMapY-1][0].CZ3=C1;
  C1=getpixel(TempSeg,MaxGroundMapX,0);
  GroundMap[MaxGroundMapX-1][0][0].CZ4=C1;

  for(Yi=1;Yi<MaxGroundMapY;Yi++){
   C1=getpixel(TempSeg,MaxGroundMapX,Yi);
   GroundMap[MaxGroundMapX-1][Yi-1][0].CZ2=C1;
   GroundMap[MaxGroundMapX-1][Yi][0].CZ4=C1;
  }
  for(Xi=1;Xi<MaxGroundMapX;Xi++){
   C1=getpixel(TempSeg,Xi,MaxGroundMapY);
   GroundMap[Xi][MaxGroundMapY-1][0].CZ3=C1;
   GroundMap[Xi-1][MaxGroundMapY-1][0].CZ2=C1;
  }

  Temp2Seg=load_bmp("TEXTURE.BMP",Pal);
  for(Yi=0;Yi<MaxGroundMapY;Yi++)
  for(Xi=0;Xi<MaxGroundMapX;Xi++){
   C1=getpixel(Temp2Seg,Xi,Yi);
   if(C1==5)C1=random()%4+21;
   if(C1==4)C1=random()%5+16;
   if(C1==3)C1=random()%5+11;
   if(C1==2)C1=random()%5+6;
   if(C1==1)C1=random()%5+1;
   GroundMap[Xi][Yi][0].SI1=C1;
   GroundMap[Xi][Yi][0].LightOpt=3; //3
   GroundMap[Xi][Yi][0].LightC=makecol(((MaxGroundMapX-Xi+0.0)/MaxGroundMapY)*255.0,((MaxGroundMapY-Yi+0.0)/MaxGroundMapY)*255.0,127);
   GroundMap[Xi][Yi][0].LightPercent=50; //((MaxGroundMapY-Yi)/MaxGroundMapY+0.0)*100.0;
  }

  // Set best available color depth
  set_color_depth(16);
  if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
   set_color_depth(15);
   if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
    set_color_depth(32);
    if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
     set_color_depth(24);
     if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
      allegro_exit();
      printf("Error setting graphics mode\n%s\n\n", allegro_error);
      return 1;
     }
    }
   }
  }

  VirSeg=load_pcx("IMAGES/WAIT1.PCX",Pal);
  Temp2Seg=load_bmp("TEXTURE.BMP",Pal);
  TempSeg=load_bmp("MAP.BMP",Pal);
  blit(TempSeg,VirSeg,0,0,280,200,26,26);
  blit(Temp2Seg,VirSeg,0,0,320,200,26,26);
  blit(VirSeg,screen,0,0,0,0,640,480);

  //for(Yi=0;Yi<MaxGroundMapY;Yi++)
  //for(Xi=0;Xi<MaxGroundMapX;Xi++){
   //GroundMap[Xi][Yi][0].LightC=makecol((Yi)*255/MaxGroundMapY,(MaxGroundMapY-Yi)*255/MaxGroundMapY/2,(MaxGroundMapY-Yi)*255/MaxGroundMapY);
   //GroundMap[Xi][Yi][0].LightC=makecol(255,255,255);
   //GroundMap[Xi][Yi][0].MZ=((GroundMap[Xi][Yi][0].CZ1+GroundMap[Xi][Yi][0].CZ2+GroundMap[Xi][Yi][0].CZ3+GroundMap[Xi][Yi][0].CZ4)/4.0);
   //GroundMap[Xi][Yi][0].LightOpt=50.0-(
   // (((GroundMap[Xi][Yi][0].CZ1+GroundMap[Xi][Yi][0].CZ4)/2.0)
   // -GroundMap[Xi][Yi][0].MZ))*100.0/255.0;
  //}

  clear(VirSeg);
  clear(GroundMapSeg);
  FillGroundMapSegPassiveArea();

  Zi=0;
  for(Yi=0;Yi<MaxGroundMapY;Yi++)
  for(Xi=0;Xi<MaxGroundMapX;Xi++){
   if((GroundMap[Xi][Yi][Zi].SI1>5)&&(GroundMap[Xi][Yi][Zi].SI1<11)){
    if(((GroundMap[Xi][Yi-1][Zi].SI1>10)&&(GroundMap[Xi][Yi-1][Zi].SI1<16))
    &&((GroundMap[Xi][Yi+1][Zi].SI1>0)&&(GroundMap[Xi][Yi+1][Zi].SI1<6)))GroundMap[Xi][Yi][Zi].SI1=6;

    if(((GroundMap[Xi-1][Yi-1][Zi].SI1>10)&&(GroundMap[Xi-1][Yi-1][Zi].SI1<16))
    &&((GroundMap[Xi][Yi-1][Zi].SI1>5)&&(GroundMap[Xi][Yi-1][Zi].SI1<11))
    &&((GroundMap[Xi+1][Yi-1][Zi].SI1>0)&&(GroundMap[Xi+1][Yi-1][Zi].SI1<6))
    &&((GroundMap[Xi-1][Yi][Zi].SI1>5)&&(GroundMap[Xi-1][Yi][Zi].SI1<11))
    &&((GroundMap[Xi+1][Yi][Zi].SI1>0)&&(GroundMap[Xi+1][Yi][Zi].SI1<6))
    &&((GroundMap[Xi-1][Yi+1][Zi].SI1>0)&&(GroundMap[Xi-1][Yi+1][Zi].SI1<6))
    &&((GroundMap[Xi][Yi+1][Zi].SI1>0)&&(GroundMap[Xi][Yi+1][Zi].SI1<6))
    &&((GroundMap[Xi+1][Yi+1][Zi].SI1>0)&&(GroundMap[Xi+1][Yi+1][Zi].SI1<6))){
     GroundMap[Xi][Yi][Zi].SI1=7;
    }
   }
  }

   /*
   RX=Xi;
   RY=Yi;
   R2=Xi*Xi+Yi*Yi;
   GroundMap[RX][RY][0].CZ2=R2;
   GroundMap[RX+1][RY][0].CZ3=R2;
   GroundMap[RX][RY+1][0].CZ4=R2;
   GroundMap[RX+1][RY+1][0].CZ1=R2;
   */
/*  GroundMap[0][0][0].SI1=17;
  GroundMap[1][0][0].SI1=16;
  GroundMap[2][0][0].SI1=17;
  GroundMap[0][1][0].SI1=16;
  GroundMap[1][1][0].SI1=9;
  GroundMap[2][1][0].SI1=16;
  GroundMap[0][2][0].SI1=17;
  GroundMap[1][2][0].SI1=16;
  GroundMap[2][2][0].SI1=17;

  GroundMap[0][0][0].Rotate=1;
  GroundMap[1][0][0].Rotate=1;
  GroundMap[2][0][0].Rotate=2;
  GroundMap[0][1][0].Rotate=3;
  GroundMap[1][1][0].Rotate=0;
  GroundMap[2][1][0].Rotate=2;
  GroundMap[0][2][0].Rotate=3;
  GroundMap[1][2][0].Rotate=0;
  GroundMap[2][2][0].Rotate=0;
*/


  for(Yi=0;Yi<MaxGroundMapY;Yi++)
  for(Xi=0;Xi<MaxGroundMapX;Xi++){
   PlaceGroundTile(GroundMapSeg,(GroundMapSegX/2)+95+Xi*44-Yi*44,50+Yi*14+Xi*14,Xi,Yi,0,GroundMap[Xi][Yi][0].SI1,1,1);
  }

  //FillGroundMapSegPassiveArea();

    //PlaceGroundTile(100,100,0,1);
    //PlaceGroundTile(100,100,0,2);
//   PlaceGroundTile(20,20,0,0);
//   PlaceGroundTile(100,100,0,1);
//  GroundTileSeg=load_bitmap("TEST45.PCX",Pal);
//   PlaceGroundTile(100,100,0,2);
//   PlaceGroundTile(100,100,0,3);

  // PlaceGroundTile(177,100,0,2);
  // PlaceGroundTile(138,158,0,1);

  ColorSegPassiveArea(BackImageSeg,1,makecol(255,255,0),makecol(0,0,134));

  ScrollBackground:
  clear_keybuf();
  blit(BackImageSeg,VirSeg,0,0,0,0,640,480);
  masked_blit(GroundMapSeg,VirSeg,MapX,MapY,0,0,640,480);

  do{   // THIS IS A MAJOR MAJOR MAJOR MAJOR LOOP!!!!
   show_mouse(VirSeg);
   textprintf(VirSeg,font,0,0,255,"Mouse (%i,%i,%i)    View at (%i,%i)    Added Mouse Result (%i,%i)      ",mouse_x,mouse_y,mouse_b,MapX,MapY,mouse_x+MapX,mouse_y+MapY);
   textprintf(VirSeg,font,0,10,255,"Passive = (%i)    C1 = (%i)        C2 = (%i)   ",(makecol(255,0,255)),(makecol(0,0,255)),(makecol(0,134,255)));
   textprintf(VirSeg,font,0,20,255,"GroundMapSeg Color at (%i,%i) = %i      ",mouse_x+MapX,mouse_y+MapY,getpixel(GroundMapSeg,mouse_x+MapX,mouse_y+MapY));
   blit(VirSeg,screen,0,0,0,0,640,480);
   if((MX!=mouse_x)||(MY!=mouse_y)){
    MXO=MX;
    MYO=MY;
    MX=mouse_x;
    MY=mouse_y;
   }
   show_mouse(0);

   Key='~';
   if(keypressed())Key=(readkey()>>8);

   ReKey:

   if(Key==KEY_UP){
    if(MapY>0)MapY=MapY-10;
    goto ScrollBackground;
   }
   if(Key==KEY_DOWN){
    if(MapY<(GroundMapSegY-480))MapY=MapY+10;
    goto ScrollBackground;
   }
   if(Key==KEY_LEFT){
    if(MapX>0)MapX=MapX-10;
    goto ScrollBackground;
   }
   if(Key==KEY_RIGHT){
    if(MapX<(GroundMapSegX-640))MapX=MapX+10;
    goto ScrollBackground;
   }

   if(Key==KEY_C){
    //get_pallete(Pal);
    save_pcx("CAPTURE.PCX",VirSeg,Pal);
   }

   BackInLoop:

  }while((Key!=KEY_Q)&&(Key!=KEY_ESC));
  Key='~';
  ExitStuff();
 }