/* ROTATE THE PALETTE TEST
 * (c) 1999. Glen H. Barratt Productions
 *
 * Glen H. Barratt CS3H
 *
 * Code Started: Friday, 2/5/1999
 * Code Last Updated: Tuesday, 6/23/1999
 *
 * Programmed With: Allegro in DJGPP
 */

 // NOTES //

 // INCLUDES //

 #include <stdlib.h>
 #include <stdio.h>
 #include <dos.h>
 #include <dirent.h>
 #include "allegro.h"

 // DEFINES //
 #define MaxGroundMapX 25
 #define MaxGroundMapY 25

 // VARIABLES //

 BITMAP *VirSeg,*TempSeg,*Temp2Seg,*Temp3Seg;
 BITMAP *GroundTileSeg;
 PALETTE Pal;

 char Key;
 unsigned char RPos;
 unsigned int MX, MXO, MY, MYO;
 unsigned int Xi,Yi,Zi;
 int i,i2,i3;
 unsigned char GroundMap[25][25][10];

 struct time Time;
 struct dirent *de;

 // FUNCTIONS //

 int Show(char *Name){
  TempSeg=load_bitmap(Name,Pal);
  if(!TempSeg)return -1;
  blit(TempSeg,screen,0,0,0,0,640,480);
  while(!keypressed());
  if((readkey() & 0xFF)==27)return 1;
  return 1;
 }

 int DisplayRPal(BITMAP *InSeg,int InX,int InY,int R){
  int Xi,Yi,Ci;
  for(Yi=0;Yi<480;Yi++)
  for(Xi=0;Xi<640;Xi++){
   Ci=getpixel(InSeg,Xi,Yi);
   putpixel(VirSeg,InX+Xi,InY+Yi,Ci+R);
  }
 }

 int DimScreen(int mode,int Color,BITMAP *DestSeg){
  int i,i2,i3,i4,Color2;
  unsigned char gr,gg,gb;
  mode=2;
  if(mode<5){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    putpixel(DestSeg,i*2,i2*2,Color);
   }
   if(mode>1){
    for(i2=0;i2<480/2;i2++)
    for(i=0;i<640/2;i++){
     putpixel(DestSeg,i*2+1,i2*2+1,Color);
    }
   }
  }
  if(mode==5){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    Color2=getpixel(DestSeg,i*2+1,i2*2)+(random()%Color);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==6){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    Color2=((getpixel(DestSeg,i*2,i2*2)+getpixel(DestSeg,i*2+1,i2*2)+
    getpixel(DestSeg,i*2,i2*2+1)+getpixel(DestSeg,i*2+1,i2*2+1))/4);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==7){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    gr=((getr(getpixel(DestSeg,i*2+1,i2*2))+getb(Color))/2);
    gg=((getg(getpixel(DestSeg,i*2+1,i2*2))+getb(Color))/2);
    gb=((getb(getpixel(DestSeg,i*2+1,i2*2))+getb(Color))/2);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==8){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    gr=((getr(getpixel(DestSeg,i*2,i2*2))+getr(getpixel(DestSeg,i*2+1,i2*2))+
    getr(getpixel(DestSeg,i*2,i2*2+1))+getr(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gg=((getg(getpixel(DestSeg,i*2,i2*2))+getg(getpixel(DestSeg,i*2+1,i2*2))+
    getg(getpixel(DestSeg,i*2,i2*2+1))+getg(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gb=((getb(getpixel(DestSeg,i*2,i2*2))+getb(getpixel(DestSeg,i*2+1,i2*2))+
    getb(getpixel(DestSeg,i*2,i2*2+1))+getb(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
  }
  if(mode==9){
   for(i2=0;i2<480/2;i2++)
   for(i=0;i<640/2;i++){
    gr=((getr(getpixel(DestSeg,i*2,i2*2))+getr(getpixel(DestSeg,i*2+1,i2*2))+
    getr(getpixel(DestSeg,i*2,i2*2+1))+getr(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gg=((getg(getpixel(DestSeg,i*2,i2*2))+getg(getpixel(DestSeg,i*2+1,i2*2))+
    getg(getpixel(DestSeg,i*2,i2*2+1))+getg(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    gb=((getb(getpixel(DestSeg,i*2,i2*2))+getb(getpixel(DestSeg,i*2+1,i2*2))+
    getb(getpixel(DestSeg,i*2,i2*2+1))+getb(getpixel(DestSeg,i*2+1,i2*2+1))+
    4*getb(Color))/8);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2,i2*2,Color2);
    putpixel(DestSeg,i*2+1,i2*2,Color2);
    putpixel(DestSeg,i*2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
   }
   for(i2=0;i2<480/2-1;i2++)
   for(i=0;i<640/2-1;i++){
    gr=((getr(getpixel(DestSeg,i*2+1,i2*2+1))+getr(getpixel(DestSeg,i*2+2,i2*2+1))+
    getr(getpixel(DestSeg,i*2+1,i2*2+2))+getr(getpixel(DestSeg,i*2+2,i2*2+2)))/4);
    gg=((getg(getpixel(DestSeg,i*2+1,i2*2+1))+getg(getpixel(DestSeg,i*2+2,i2*2+1))+
    getg(getpixel(DestSeg,i*2+1,i2*2+2))+getg(getpixel(DestSeg,i*2+2,i2*2+2)))/4);
    gb=((getb(getpixel(DestSeg,i*2+1,i2*2+1))+getb(getpixel(DestSeg,i*2+2,i2*2+1))+
    getb(getpixel(DestSeg,i*2+1,i2*2+2))+getb(getpixel(DestSeg,i*2+2,i2*2+2)))/4);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i*2+1,i2*2+1,Color2);
    putpixel(DestSeg,i*2+2,i2*2+1,Color2);
    putpixel(DestSeg,i*2+1,i2*2+2,Color2);
    putpixel(DestSeg,i*2+2,i2*2+2,Color2);
   }
  }
  if(mode==10){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+getr(Color))/2);
    gg=((getg(getpixel(DestSeg,i,i2))+getg(Color))/2);
    gb=((getb(getpixel(DestSeg,i,i2))+getb(Color))/2);
    Color2=makecol(gr,gg,gb);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==11){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+getr(Color)+
    getg(getpixel(DestSeg,i,i2))+getg(Color)+
    getb(getpixel(DestSeg,i,i2))+getb(Color))/6);
    Color2=makecol(gr,gr,gr);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==12){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(gr,gr,gr);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==13){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(gr,0,0);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==14){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(0,gr,0);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
  if(mode==15){
   for(i2=0;i2<480;i2++)
   for(i=0;i<640;i++){
    gr=((getr(getpixel(DestSeg,i,i2))+
    getg(getpixel(DestSeg,i,i2))+
    getb(getpixel(DestSeg,i,i2)))/3);
    Color2=makecol(0,0,gr);
    putpixel(DestSeg,i,i2,Color2);
   }
  }
 }

 int ExitStuff(){
  destroy_bitmap(VirSeg);
  destroy_bitmap(TempSeg);
  destroy_bitmap(Temp2Seg);
  destroy_bitmap(Temp3Seg);
  //remove_sound();
  remove_mouse();
  remove_timer();
  clear_keybuf();
  remove_keyboard();
  allegro_exit();
  clrscr();
  printf("PALETTE ROTATION TEST (c) 1999. Glen H. Barratt Productions.");
  exit(0);
 }

 // MAIN //

 int main(int argc,char *argv[]){
  allegro_init();
  install_keyboard();
  install_timer();
  install_mouse();

  gettime(&Time);
  srandom(Time.ti_sec);


  // Set best available color depth
//  set_color_depth(16);
//  if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
//   set_color_depth(15);
//   if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
//    set_color_depth(32);
//    if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
     set_color_depth(8);
     if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0){
      allegro_exit();
      printf("Error setting graphics mode\n%s\n\n", allegro_error);
      return 1;
     }
//    }
//   }
//  }
  //Load all images in the same color depth as the display
  //set_color_conversion(COLORCONV_TOTAL);
  Reset:

  TempSeg=load_pcx("IMAGES/GCLAIMER.PCX",Pal);
  set_palette(Pal);
  Show("IMAGES/GCLAIMER.PCX");

  VirSeg=create_bitmap(640,480);
  TempSeg=create_bitmap(640,480);
  Temp2Seg=create_bitmap(640,480);
  Temp3Seg=create_bitmap(640,480);


  clear(VirSeg);

  TempSeg=load_pcx("RCT.PCX",Pal);
  set_palette(Pal);

  GroundTileSeg=create_bitmap(640,480);
  GroundTileSeg=load_bitmap("RCT.PCX",Pal);


  do{   // THIS IS A MAJOR MAJOR MAJOR MAJOR LOOP!!!!
   show_mouse(VirSeg);
   textprintf(VirSeg,font,0,0,255,"Mouse (%i,%i,%i) Color (%i)   ",mouse_x,mouse_y,mouse_b,RPos);
   blit(VirSeg,screen,0,0,0,0,640,480);

   if((MX!=mouse_x)||(MY!=mouse_y)){
    MXO=MX;
    MYO=MY;
    MX=mouse_x;
    MY=mouse_y;
   }
   show_mouse(0);

   Key='~';
   if(keypressed())Key=(readkey()>>8);

   ReKey:

   if(Key==KEY_RIGHT){
    if(RPos==255)RPos=0;
    else RPos=RPos+1;
   }
   if(Key==KEY_LEFT){
    if(RPos==0)RPos=255;
    else RPos=RPos-1;
   }

   DisplayRPal(GroundTileSeg,0,0,RPos);

   if(Key==KEY_C){
    //get_pallete(Pal);
    save_pcx("CAPTURE.PCX",VirSeg,Pal);
   }

   BackInLoop:

  }while((Key!=KEY_Q)&&(Key!=KEY_ESC));
  Key='~';
  ExitStuff();
 }